ClearAll[AdvancedBatchMeasurementFunction,ODMRcontinuousWaveMeasurementTask,
	ODMRpulseSequenceMeasurementTask,ODMRpulsedSpectrumMeasurementTask,
	ODMRpulsedDEERspectrumMeasurementTask,ODMRspectrumFitTask,
	ODMRspectrumFitPeakExtractorTask,ODMRpulseSequenceOscillationFitTask,
	ODMRpulseSequenceOscillationFitParameterExtractorTask,
	ODMRpulsePowerCalculatorTask,ODMRdampedOscillationFit,
	BatchQuantityQ,BatchQuantity,ConditionalBatchQuantity,DerivedBatchQuantity,
	EvaluateBatchQuantity,EvaluateBatchQuantityOptions,OptionsBatchDependencies,
	BatchDependencies,BatchTask,ImportBatchResults,
	AlwaysRestart,RestartIfDependenciesChanged,
	IsMeasurementTask,SkipOnFail,AutoAdjustMapBeforeTask,AutoAdjustMapAfterTask,
	AutoAdjustMapAfterTaskEvenWithoutNewResults,
	TakeImageBeforeTask,TakeImageAfterTask,TaskCaresAboutMapAdjustment,
	TakeImageAfterTaskEvenWithoutNewResults,SymbolQ,BatchResultsImportTask,
	CharacterClassQ,StringPositionRepresentativeQ,StringExpressionQ,stringMatchQ,
	ExtractDataFromMeasurementResult];
SymbolQ[x_]:=Head[x]===Symbol;
CharacterClassQ[pattern_]:=With[{characterQ=
			Function[StringQ[#]&&StringLength[#]==1]},
		MatchQ[pattern,_?characterQ|{___?characterQ}
			|_Characters?(Length[#]==1&&StringQ[#[[1]]]&)
			|_CharacterRange?(Length[#]==2&&And@@(characterQ/@#)&)
			|HexadecimalCharacter|DigitCharacter|LetterCharacter
			|WhitespaceCharacter|WordCharacter
			|_Except?(1<=Length[#]<=2&&And@@(CharacterClassQ/@#)&)]];
StringPositionRepresentativeQ[pattern_]:=
	MatchQ[pattern,StartOfString|EndOfString|StartOfLine|EndOfLine|WordBoundary
		|_Except?(Length[#]==1&&#[[1]]===WordBoundary&)];
StringExpressionQ[pattern_]:=
	MatchQ[pattern,_String|_Blank|_BlankSequence|_BlankNullSequence
		|(_Repeated|_RepeatedNull)?(1<=Length[#]<=2&&StringExpressionQ[#[[1]]]
			&&(Length[#]==1||MatchQ[#[[2]],_Integer|{_Integer}|{_Integer|_Integer}])&)
		|WhiteSpace|NumberString|_DatePattern|RegularExpression[_String]
		|_?CharacterClassQ|_?StringPositionRepresentativeQ
		|(_Alternatives|_List|_StringExpression)?(And@@(StringExpressionQ/@#)&)
		|_Pattern?(SymbolQ[#[[1]]]&&StringExpressionQ[#[[2]]]&)
		|_PatternTest?(StringExpressionQ[#[[1]]]&)];
stringMatchQ[str_String,pattern_]:=
	If[StringExpressionQ[pattern],StringMatchQ[str,pattern],MatchQ[str,pattern]];
SetAttributes[AdvancedBatchMeasurementFunction,HoldFirst];
Options[AdvancedBatchMeasurementFunction]={
	MicrowavePowerTranslationFunction:>Function[{power,f},
		Round[power-$ODMRmicrowaveAmplifierPowerCalibrationFunction[f],0.05]],
	LaserPowerMeterFactor:>$ODMRlaserPowerMeterFactor,
	ImageSize->{15,15},
	ImagePixels->{150,150},
	ImageMaxCounts->60*^3,
	ImageCenter->Automatic,
	TrackerMaxRuns->20,
	TrackerDefaultMinCountsToStopTracking->15*^3,
	TrackerMinCountsToTrack->5*^3,
	TrackerMinCountsToFail->400*^3,
	TrackerMaxCountsVariation->0.05,
	TrackerFixedAxes->None,
	TrackerTimeBetweenAutoTracking->120,
	FileNamePrefix:>FileNameJoin[{NotebookDirectory[],"data_"}],
	NVSelectorFunction->(True&),
	AdjustScanRangeForCorrelation->False,
	CropCorrelationImage->False,
	HorizontalCorrelationOptions->{},
	HorizontalCorrelationImage->None,
	VerticalCorrelationOptions->{},
	VerticalCorrelationImage->None,
	IgnoreCorrelationFitProblems->False,
	InitialMapOffset->Automatic,
	SnapshotPrefix->"snapshot",
	SnapshotIntervall->5*60,
	TakeImageAfterEveryTask->False,
	TakeImageAfterEveryMeasurementTask->True,
	TakeImageAfterSelection->True,
	ResultsToPreview->{},
	TasksToRestart->{},
	InitialResults->{},
	ReturnAllResults->False,
	AutoAdjustMapAfterSelection->True,
	AutoAdjustMapAfterEveryTask->False,
	AutoAdjustMapAfterEveryMeasurementTask->True,
	AutoSave->True,
	QueueTasksFromResult->True,
	Debug->False};
AdvancedBatchMeasurementFunction[map_?NVmapQ,
		tasks:{___?BatchTaskQ},
		o:OptionsPattern[]]:=
	Module[{microwavePowerTranslationFunction=
				OptionValue[MicrowavePowerTranslationFunction],
			imageSize=OptionValue[ImageSize],
			imagePixels=OptionValue[ImagePixels],
			imageMaxCounts=OptionValue[ImageMaxCounts],
			imageCenter=
				Switch[#,_Function,#,{_?NumericQ,_?NumericQ,_?NumericQ},
					Function[#],_,Identity]&@OptionValue[ImageCenter],
			timesBetweenAutoTracking=OptionValue[TrackerTimeBetweenAutoTracking],
			defaultMinCountsToStopTracking=
				OptionValue[TrackerDefaultMinCountsToStopTracking],
			trackerMaxRuns=OptionValue[TrackerMaxRuns],
			minCountsToTrack=OptionValue[TrackerMinCountsToTrack],
			minCountsToFail=OptionValue[TrackerMinCountsToFail],
			maxCountsVariation=OptionValue[TrackerMaxCountsVariation],
			fixedAxes=OptionValue[TrackerFixedAxes],
			filePrefix=OptionValue[FileNamePrefix],
			NVselector=OptionValue[NVSelectorFunction],
			horizontalCorrelationImage=
				OptionValue[HorizontalCorrelationImage],
			verticalCorrelationImage=
				OptionValue[VerticalCorrelationImage],
			initialMapOffset=
				Switch[#,Automatic,
					GetCurrentMapOffset[
						map],{_?NumericQ,_?NumericQ,_?NumericQ},#,_,
					Print["Invalid map offset,ignoring: "<>ToString[#]]; {0,
						0,0}]&@OptionValue[InitialMapOffset],
			adjustScanRangeForCorrelation=
				OptionValue[AdjustScanRangeForCorrelation]===True,
			cropCorrelationImage=OptionValue[CropCorrelationImage]===True,
			ignoreCorrelationFitProblems=
				OptionValue[IgnoreCorrelationFitProblems]===True,
			horizontalCorrelationOptions=
				Sequence@@OptionValue[HorizontalCorrelationOptions],
			verticalCorrelationOptions=
				Sequence@@OptionValue[VerticalCorrelationOptions],
			snapshotPrefix=OptionValue[SnapshotPrefix],
			snapshotIntervall=OptionValue[SnapshotIntervall],
			takeImageAfterEveryTask=
				OptionValue[TakeImageAfterEveryTask]===True,
			takeImageAfterEveryMeasurementTask=
				OptionValue[TakeImageAfterEveryMeasurementTask]===True,
			takeImageAfterSelection=
				OptionValue[TakeImageAfterSelection]===True,
			resultsToPreview=If[ListQ[#],Alternatives@@#,#]&@
				OptionValue[ResultsToPreview],
			tasksToRestart=OptionValue[TasksToRestart],
			initialResults=OptionValue[InitialResults],
			autoAdjustMapAfterSelection=
				OptionValue[AutoAdjustMapAfterSelection]===True,
			autoAdjustMapAfterEveryTask=
				OptionValue[AutoAdjustMapAfterEveryTask]===True,
			autoAdjustMapAfterEveryMeasurementTask=
				OptionValue[AutoAdjustMapAfterEveryMeasurementTask]===True,
			autoSave=OptionValue[AutoSave]=!=False,
			queueTasksFromResult=OptionValue[QueueTasksFromResult]===True,
			debug=OptionValue[Debug]===True},
		Module[{quit=False,abort=False,skip=False,NV,image,restoreLatestSnapshot,
				adjustMap,adjustMapNoSkip,scanImage,makeImage,minCountsToStop,
				lastCorrelationImage,symbolQ=Function[MatchQ[#,_Symbol]],
				mCurrentTask,mExecutableTasks,tasksToExecute,saveData,results},
			adjustMapNoSkip=Function[minCountsToStop,
				If[!abort,
					AutoAdjustCurrentNVPosition[map,
						TrackerMinCountsToStop->minCountsToStop,
						TrackerMinCountsToTrack->minCountsToTrack,
						TrackerMinCountsToFail->minCountsToFail,
						TrackerMaxRuns->trackerMaxRuns,
						TrackerMaxCountsVariation->maxCountsVariation,
						FixedAxes->fixedAxes,
						ReturnOldMapOnFail->False,OptimizeBelowMinCounts->{}]]];
			adjustMap=Function[minCountsToStop,
				If[!abort,If[#=!=$Failed,map=#,Print["skipping"]; skip=True]&@
					adjustMapNoSkip[minCountsToStop]]];
			scanImage=
			Function[
				Module[{c=
						Clip[#[[1]],{#[[3]]/2,#[[2]]-#[[3]]/2}]&/@
							Transpose[{#[[1 ;; 2]],GetStageRange[][[1 ;; 2]],
								imageSize}]},
					ScanConfocalImage[1,c[[1]]-imageSize[[1]]/2,
						c[[1]] + imageSize[[1]]/2,imagePixels[[1]],2,
						c[[2]]-imageSize[[2]]/2,c[[2]] + imageSize[[2]]/2,
						imagePixels[[2]],#[[3]]]]&@
				imageCenter@GetCurrentNVposition@map];
			makeImage=Function[If[ConfocalImageQ[verticalCorrelationImage],
					Module[{notZvalue,notZaxis,axes,range,dims,zAxisIndex},
						{notZvalue,notZaxis,axes,range,dims}=
							#[verticalCorrelationImage]&/@
								{GetConfocalImageNormalAxisValue,GetConfocalImageNormalAxis,
									GetConfocalImageAxes,GetConfocalImageRange,
									GetConfocalImageDimensions};
						zAxisIndex=Position[axes,3][[1,1]];
						If[notZvalue===Indeterminate,
						notZvalue=Mean[#[[2]]&/@map[[1]]][[notZaxis]]];
						CorrelateConfocalImages[verticalCorrelationImage,#,
							verticalCorrelationOptions,MaxSize->10,FreeFitSize->10]&@
						ScanConfocalImage[##,
							notZvalue+GetCurrentMapOffset[map][[notZaxis]]]&@@ 
						Flatten@Transpose[{axes,range+
									If[adjustScanRangeForCorrelation,
										GetCurrentMapOffset[map][[axes]],0],
								dims}]//
						(lastCorrelationImage=#[[1]];
							Switch[#[[2]],{_Style,__},#[[2,1,1,1,1+zAxisIndex,2]],
								_,Print["vertical fit problem"];Print[#];
									If[!ignoreCorrelationFitProblems,abort=True];
									#[[2,1,zAxisIndex]]])&//
						(map=AdjustCurrentNVPosition[map,
								GetCurrentNVposition[map]+{0,0,#+initialMapOffset[[3]]-
									GetCurrentMapOffset[map][[3]]}])&]];
					Module[{scannedImage},
						If[ConfocalImageQ[horizontalCorrelationImage],
							Module[{zValue,zAxis,axes,range,dims},
								If[cropCorrelationImage,
									scannedImage=scanImage[];
									{zValue,zAxis,axes,range,dims}=#[scannedImage]&/@
										{GetConfocalImageNormalAxisValue,
											GetConfocalImageNormalAxis,GetConfocalImageAxes,
											GetConfocalImageRange,GetConfocalImageDimensions};
									CorrelateConfocalImages[
										CropConfocalImage[horizontalCorrelationImage,
											First/@range,-Subtract @@ #&/@range],
										scannedImage,horizontalCorrelationOptions],
									{zValue,zAxis,axes,range,dims}=
										#[horizontalCorrelationImage]&/@
										{GetConfocalImageNormalAxisValue,GetConfocalImageNormalAxis,
											GetConfocalImageAxes,GetConfocalImageRange,
											GetConfocalImageDimensions};
									If[zValue===Indeterminate,
									zValue=Mean[#[[2]]&/@map[[1]]][[zAxis]]];
									CorrelateConfocalImages[horizontalCorrelationImage,
											scannedImage=#,horizontalCorrelationOptions]&@
									ScanConfocalImage[##,
										zValue+GetCurrentMapOffset[map][[zAxis]]]&@@ 
									Flatten@Transpose[{axes,
											range+If[adjustScanRangeForCorrelation,
												GetCurrentMapOffset[map][[axes]],0],
											dims}]]//
								(lastCorrelationImage=#[[1]];
									{#,Cases[#[[2;;]],{_Style,__}]}// 
									If[Length[#[[2]]]>0,#[[2,1,1,1,1,2;;3,2]],
										Print["horizontal fit problem"];Print[#[[1]]]; 
										If[!ignoreCorrelationFitProblems,abort=True];
										#[[1,2,1,1;; 2]]]&)&//
								(map=AdjustCurrentNVPosition[map,
									GetCurrentNVposition[map]+
									Append[#+initialMapOffset[[{1,2}]]-
										GetCurrentMapOffset[map][[{1,2}]],0]];
									adjustMap[minCountsToStop];)&
						],
						scannedImage=scanImage[]];
					image=PlotAndAnnotateConfocalImage[scannedImage,map]]];
			restoreLatestSnapshot=Function[snapshotDirectory,
				If[Length[#]>0,
					Get[FileNameJoin[{snapshotDirectory,
								snapshotPrefix<>"_"<>ToString[#]<>".m"}]]&@
					Max[StringCases[#,
							StartOfString~~snapshotPrefix~~"_"~~x:NumberString~~".m"
								~~EndOfString:>ToExpression[x]][[1]]&@
						Last@FileNameSplit[#]&/@#],None]&@
				FileNames[snapshotPrefix<>"*.m",{snapshotDirectory}]];
			Monitor[Module[{fileName=Function[filePrefix<>NV<>".m"],
						previousResultFor,startTime=SessionTime[],
						newResults,previousResults},
					results={};
					skip=False;
					minCountsToStop=defaultMinCountsToStopTracking;
					If[!quit&&!abort&&!skip,
						NV=#[[1]];
						time=0;
						previousResults=If[Head[#]===$Failed,
							Print@@Append[#,", ignoring"];{},
							#]&@ImportBatchResults@fileName[];
						previousResultFor=Function[revesePreviousResults,
							Function[#/.revesePreviousResults
								/.#->If[Length[{##}]>1,{##}[[2]]]]]@
							Reverse@previousResults;
						results=Join[initialResults,
							{"ID"->NV,"Time"->previousResultFor["Time",0],"Map"->map,
								"File"->fileName[]}];
						newResults={};
						saveData=Function[
							time=SessionTime[]-startTime;
							(Put[#,fileName[]];#)&@
								Join[{"ID"->NV},DeleteCases[previousResults,"ID"->_],
									{"Time"->(previousResultFor["Time",0]+time),"Map"->map},
									newResults]];
						If[!abort&&!skip,
							map=ChangeCurrentNVbyTag[map,NV];
							If[autoAdjustMapAfterSelection,adjustMap[minCountsToStop]];
							If[takeImageAfterSelection,
								(AppendTo[results,#];AppendTo[newResults,#])&[
									"ImageAfterSelection"->makeImage[]];
								If[!skip&&autoAdjustMapAfterSelection,
									adjustMap[minCountsToStop]]];
						];
						tasksToExecute=tasks;
						While[!abort&&!skip&&Length[tasksToExecute]>0,
							Function[executableTasks,
								mExecutableTasks=executableTasks;
								If[Length[executableTasks]>0,
									Function[currentTask,If[!abort&&!skip,
										mCurrentTask=currentTask;
										tasksToExecute=Complement[tasksToExecute,{currentTask}];
										mExecutableTasks=Complement[mExecutableTasks,{currentTask}];
										Module[{taskName=currentTask[[1]],
												taskRequirements=currentTask[[2]],
												taskFunction=currentTask[[3]],
												taskAttributes=
													If[Length[currentTask]>3,
														If[ListQ[#],#,{#}]&@currentTask[[4]],{}],
												isMeasurementTask},
											isMeasurementTask=
												MemberQ[taskAttributes,IsMeasurementTask];
											Module[{snapshotDirectory=
														filePrefix<>NV<>"_"<>taskName,
													restartMeasurement=
														MemberQ[taskAttributes,AlwaysRestart]
														||(MemberQ[taskAttributes,
																RestartIfDependenciesChanged]
															&&Length@Intersection[taskRequirements,
																First/@newResults]>0)
														||stringMatchQ[taskName,NV/.tasksToRestart/.NV->{}],
													skipOnFail=MemberQ[taskAttributes,SkipOnFail],
													autoAdjustMapBefore=
														MemberQ[taskAttributes,AutoAdjustMapBeforeTask],
													autoAdjustMapAfter=autoAdjustMapAfterEveryTask
														||isMeasurementTask
															&&autoAdjustMapAfterEveryMeasurementTask
														||MemberQ[taskAttributes,AutoAdjustMapAfterTask],
													autoAdjustMapAfterEvenWithoutNewResults=
														MemberQ[taskAttributes,
															AutoAdjustMapAfterTaskEvenWithoutNewResults],
													takeImageBefore=
														MemberQ[taskAttributes,TakeImageBeforeTask],
													takeImageAfter=takeImageAfterEveryTask
														||isMeasurementTask&&
															takeImageAfterEveryMeasurementTask
														||MemberQ[taskAttributes,TakeImageAfterTask]
														||MemberQ[taskAttributes,
															TakeImageAfterTaskEvenWithoutNewResults],
													takeImageAfterEvenWithoutNewResults=
														MemberQ[taskAttributes,
															TakeImageAfterTaskEvenWithoutNewResults],
													taskCaresAboutMapAdjustment=MemberQ[taskAttributes,
															TaskCaresAboutMapAdjustment],
													newResultsForThisTask},
												If[autoAdjustMapBefore&&!taskCaresAboutMapAdjustment,
													adjustMap[minCountsToStop]];
												If[takeImageBefore,
													(AppendTo[results,#];AppendTo[newResults,#])&[
														("ImageBefore"<>taskName)->makeImage[]];
													If[autoAdjustMapBefore,adjustMap[minCountsToStop]];
												];
												(newResultsForThisTask=#;
													newResults=Join[newResults,#])&@
												Complement[#,previousResults]&@
												(results=Join[results,#];#)&@
												(If[MemberQ[#,TrackerMinCountsToStop->_],
													minCountsToStop=TrackerMinCountsToStop/.List@@#];#)&@
												If[Head[#]===$Failed,
													skip=skipOnFail;List@@#,
													If[MatchQ[queueTasksFromResult,True|All]
															||stringMatchQ[taskName,queueTasksFromResult],
														tasksToExecute=Join[tasksToExecute,
															Cases[#,_?BatchTaskQ]]];
													Cases[#,_Rule]]&@
												Switch[#,_Rule|_?BatchTaskQ,{#},
													(List|$Failed)[(_Rule|_?BatchTaskQ)...],#,
													$Failed[_],$Failed[#]&[taskName->#[[1]]],
													$Failed[___],$Failed[#]&[taskName->(List@@#)],
													Null|None,{},_,{taskName->#}]&@
												taskFunction[map,{
														TrackerEnabled->True,
														TrackerMaxRuns->trackerMaxRuns,
														TrackerMinCountsToStop->minCountsToStop,
														TrackerMinCountsToTrack->minCountsToTrack,
														TrackerMinCountsToFail->minCountsToFail,
														TrackerMaxCountsVariation->maxCountsVariation,
														FixedAxes->fixedAxes,
														TimeBetweenAutoTracking->timesBetweenAutoTracking,
														SnapshotFilePrefix->FileNameJoin[{snapshotDirectory,
															snapshotPrefix}],
														SnapshotIntervall->snapshotIntervall,
														PreviousData->If[!restartMeasurement,
															If[!SymbolQ[#],#,previousResultFor[taskName]]&
															@restoreLatestSnapshot[snapshotDirectory]],
														LaserPowerMeterFactor->laserPowerMeterFactor,
														MicrowavePowerTranslationFunction->
															microwavePowerTranslationFunction,
														PreviousResults->previousResults},
													results];
												If[autoAdjustMapAfter
														&&(autoAdjustMapAfterEvenWithoutNewResults
															||Length[newResultsForThisTask]>0)
														&&!taskCaresAboutMapAdjustment,
													adjustMap[minCountsToStop]];
												If[takeImageAfter
														&&(takeImageAfterEvenWithoutNewResults
															||Length[newResultsForThisTask]>0),
													(AppendTo[results,#];AppendTo[newResults,#])&[
														("ImageAfter"<>taskName)->makeImage[]];
												];
											];
										];
										If[autoSave,saveData[]];
									]]/@executableTasks
									,
									If[Length[tasksToExecute]>0,
										Print["no suitable task found to continue with for "<>
										NV<>", skipping"<>If[debug,StringJoin[" (",Riffle[
												StringJoin[#[[1]],"(",Riffle[
														Switch[#,_List,StringJoin@Riffle[#0/@#],
															_String,#,
															_BatchQuantity|_ConditionalBatchQuantity
																|_DerivedBatchQuantity,#0@#[[1]],
															_,ToString[#]]&/@
														Select[#[[2]],
															!BatchDependenciesFulfilled[#,results]&],
														","],")"]&/@
												tasksToExecute,","],")"],""]]];
									Break[]
							]]@Select[tasksToExecute,BatchDependenciesFulfilled[#,results]&];
						];
						mCurrentTask=.;
						If[autoSave,saveData[]];
						saveData=.;
						NV->results
					]]&/@Select[map[[1]],NVselector[#[[1]]]&]
				,{Button[If[abort,"doNotAbort","abort"],abort=!abort],
				Button[If[quit,"doNotQuit","quit"],quit=!quit],
				Button[If[skip,"doNotSkip","skip"],skip=!skip],
				Button["save",saveData[]],
				NV,time,If[SymbolQ[#],"",#[[1]]]&@mCurrentTask,
				Tooltip[Length[mExecutableTasks],First/@mExecutableTasks],
				Tooltip[Length[tasksToExecute],First/@tasksToExecute],
				If[SymbolQ[#],"",
						PlotAndAnnotateConfocalImage[#,map,MaxCounts->imageMaxCounts]
					]&@image,
				If[SymbolQ[#],"",#]&@lastCorrelationImage,
				Select[results,stringMatchQ[#[[1]],resultsToPreview]&]}]//
		If[OptionValue[ReturnAllResults]===True,#]&	
	]];
BatchTaskQ[x_]:=MatchQ[x,
	BatchTask[_String,{___?BatchQuantityQ},_Function,_:{}]];
BatchQuantityQ[x_]:=
	MatchQ[x,Except[{},_String|_?StringExpressionQ
			|BatchQuantity[_String|_?StringExpressionQ]
			|ConditionalBatchQuantity[_String|_?StringExpressionQ,_Function]
			|DerivedBatchQuantity[{(_String|_?StringExpressionQ)...},_Function,
				_Function:(True&)]]];
Options[EvaluateBatchQuantity]={ResultPicker->Last};
EvaluateBatchQuantity[x_,results:{(_String->_)...},o:OptionsPattern[]]:=
	Switch[x,
		_?BatchQuantityQ,
		Module[{sec=Switch[#,_Rule,#[[2]],_List,#0/@#,_,#]&,
				resultPicker=Switch[#,First|Last,#,All|None,#&,_Function,#,_,Last]&
					@OptionValue[ResultPicker]},
			Module[{rif=Function[f,Function[matchingResults,
							If[Length[matchingResults]>0,f@resultPicker[matchingResults],
								UnfulfilledDependencies[x]]]]},
				Switch[x,
					_String,rif[sec]@Cases[results,HoldPattern[x->_]],
					_?StringExpressionQ,rif[sec]@Cases[results,
							_Rule?(StringMatchQ[#[[1]],x]&)],
					_BatchQuantity,EvaluateBatchQuantity[x[[1]],results],
					_ConditionalBatchQuantity,rif[sec]@Cases[results,
							_Rule?(StringMatchQ[#[[1]],x[[1]]]&&x[[2]][#[[2]]]&)],
					_DerivedBatchQuantity,
						rif[
							Switch[#,{___Rule},x[[2]]@@sec[#],
								{{___Rule}...},x[[2]]@@sec[#]&/@#,
								_,Print["ResultPicker should return a single result rule list"
										<>" or a list of such, treating as the first: "
										<>ToString[#]];
								x[[2]]@@sec[#]]&
						]@With[{select=If[Length[x]>2,Select[#,x[[3]]@@sec[#]&]&,Identity]},
							select@Tuples[
									Function[y,Cases[results,_Rule?(StringMatchQ[#[[1]],y]&)]]/@
									x[[1]]]]]]],
		_List,EvaluateBatchQuantity[#,results]&/@x,
		_,x];
EvaluateBatchQuantityOptions[o:{OptionsPattern[]},results:{(_String->_)...}]:=
	Switch[#,
		Rule[_,(_BatchQuantity|_ConditionalBatchQuantity
				|_DerivedBatchQuantity)?BatchQuantityQ],
		MapAt[EvaluateBatchQuantity[#,results]&,#,2],
		_List,#0/@#,
		_,#]&@o;
BatchDependencies[x_]:=
	Switch[x,_List,Flatten[BatchDependencies/@x],
		_String|_?StringExpressionQ,{x},
		(_BatchQuantity|_ConditionalBatchQuantity)?BatchQuantityQ,{x[[1]]},
		_DerivedBatchQuantity?BatchQuantityQ,x[[1]],
		_,{}];
OptionsBatchDependencies[o___]:=
	Flatten[If[MatchQ[#,Rule[_,(_BatchQuantity|_ConditionalBatchQuantity
					|_DerivedBatchQuantity)?BatchQuantityQ]],BatchDependencies[#[[2]]],{}
			]&/@Flatten[{o}]];
BatchDependenciesFulfilled[x_,results:{(_String->_)...}]:=
	Switch[x,_?BatchQuantityQ,
			Switch[x,
				_String|_?StringExpressionQ,
					LengthWhile[results,!StringMatchQ[#[[1]],x]&]<Length[results],
				_BatchQuantity,BatchDependenciesFulfilled[x[[1]]],
				_ConditionalBatchQuantity,LengthWhile[results,
						!(StringMatchQ[#[[1]],x[[1]]]&&x[[2]][#[[2]]])&]<Length[results],
				DerivedBatchQuantity[_,_],
					And@@(BatchDependenciesFulfilled[#,results]&/@x[[1]]),
				DerivedBatchQuantity[_,_,_],Or@@(x[[3]]@@#&/@Tuples[
						Function[y,Cases[results,(_?(StringMatchQ[#,y]&)->v_):>v]]/@x[[1]]])
			],
		_List,And@@(BatchDependenciesFulfilled[#,results]&/@x),
		_?BatchTaskQ,And@@(BatchDependenciesFulfilled[#,results]&/@x[[2]]),
		_,True];
Options[BatchConditionTask]={Attributes->AlwaysRestart};
BatchConditionTask[name_String,condition:_DerivedBatchQuantity?BatchQuantityQ,
		o:OptionsPattern[]]:=
	BatchTask[name,BatchDependencies[condition],
		Function[{map,options,otherResults},
			If[EvaluateBatchQuantity[condition,otherResults]===True,
				{name->True},{}],
			{HoldFirst}],
		OptionValue[Attributes]];
Options[BatchResultsImportTask]={
	TaskName->"BatchResultsImportTask",ResultsToDelete->"ID"|"Map"|"Time",
	AdditionalDependencies->{},Attributes->AlwaysRestart};
BatchResultsImportTask[file:_String|_Function|_?BatchQuantityQ,
		o:OptionsPattern[]]:=
	Function[{resultsToDelete},
		BatchTask[OptionValue[TaskName],
			Flatten@{OptionValue[AdditionalDependencies]},
			Function[{map,options,otherResults},
				Select[#,!stringMatchQ[#[[1]],resultsToDelete]&]&@
				If[Head[#]===$Failed,Print[#[[1]]];{},#]&@
				If[Head[file]===Function,ImportBatchResults@file[GetCurrentNVtag[map]],
					If[Length[#]>0,First[#],{}]&@
					DeleteCases[ImportBatchResults/@
						Select[{file,EvaluateBatchQuantity[file,otherResults]},
							FileExistsQ],_$Failed]],
				{HoldFirst}],
			OptionValue[Attributes]]
	][OptionValue[ResultsToDelete]];
Options[TrackerMeasurementTask]=Join[{
		TaskName->"TrackerMeasurement",
		PreMeasurementCommand->Function[Null],
		PostMeasurementCommand->Function[Null],
		NVtoTrack->Automatic,AdditionalDependencies->{},
		Attributes->{IsMeasurementTask,TaskCaresAboutMapAdjustment,AlwaysRestart}},
	Options@ODMRautoTrack];
TrackerMeasurementTask[o:OptionsPattern[]]:=
	Function[{preMeasurementCommand,postMeasurementCommand,nvToTrack},
		BatchTask[OptionValue[TaskName],
			Flatten@{OptionValue[AdditionalDependencies]},
			Function[{map,options,otherResults},
				Module[{result,currentNV=GetCurrentNVtag[map]},
					preMeasurementCommand[map,options,otherResults];
					If[nvToTrack=!=Automatic,
						map=ChangeCurrentNVbyTag[map,nvToTrack]];
					result=If[#=!=$Failed,
							map=AdjustCurrentNVPosition[map,#[[1]]];#,
							$Failed[]]&@
						ODMRautoTrack[GetCurrentNVposition[map],
							Sequence@@EvaluateBatchQuantityOptions[
								FilterRules[Join[{o},options],Options@ODMRautoTrack],
								otherResults]];
					If[nvToTrack=!=Automatic,
						map=ChangeCurrentNVbyTag[map,currentNV]];
					postMeasurementCommand[map,options,otherResults,result];
					result],			
				{HoldFirst}],
			OptionValue[Attributes]]
		][OptionValue[PreMeasurementCommand],OptionValue[PostMeasurementCommand],
			OptionValue[nvToTrack]];
Options[AntiCorrelationMeasurementStartTask]={
		TaskName->"AntiCorrelationMeasurementStart",
		PreMeasurementCommand->Function[Null],
		PostMeasurementCommand->Function[Null],
		AdditionalDependencies->{},Attributes->AlwaysRestart};
AntiCorrelationMeasurementStartTask[o:OptionsPattern[]]:=
	Function[{preMeasurementCommand,postMeasurementCommand},
		BatchTask[OptionValue[TaskName],
			Flatten@{OptionValue[AdditionalDependencies]},
			Function[{map,options,otherResults},
				preMeasurementCommand[map,options,otherResults];
				TimeHarpStopMeasurement[];
				TimeHarpClearHistogramMemory[0];
				TimeHarpStartMeasurement[];
				postMeasurementCommand[map,options,otherResults,{}],
				{HoldFirst}],
			OptionValue[Attributes]]
		][OptionValue[PreMeasurementCommand],OptionValue[PostMeasurementCommand]];
Options[AntiCorrelationMeasurementReadTask]={
		TaskName->"AntiCorrelationMeasurementRead",
		PreMeasurementCommand->Function[Null],
		PostMeasurementCommand->Function[Null],
		Resolution->DerivedBatchQuantity[{},Function[TimeHarpGetResolution[]]],
		AdditionalDependencies->{},Attributes->AlwaysRestart};
AntiCorrelationMeasurementReadTask[o:OptionsPattern[]]:=
	Function[{preMeasurementCommand,postMeasurementCommand,resolution},
		BatchTask[OptionValue[TaskName],
			Fallten@{BatchDependencies[resolution],
				OptionValue[AdditionalDependencies]},
			Function[{map,options,otherResults},
				Module[{result,previousData=PreviousData/.options,
						rResolution=EvaluateBatchQuantity[resolution,otherResults]},
					preMeasurementCommand[map,options,otherResults];
					result=ListLinePlot[Transpose[{rResolution*(Range[Length[#]]-1),#}]&@
						Function[previousExtractedData,
							If[Length[previousExtractedData]>0,
								(#[[2]]&/@previousExtractedData[[1]])+#,#]][
							Cases[previousData,(Line|Point)[l_List]:>l,\[Infinity]]]&@
							TimeHarpGetHistogramBlock[0],PlotRange->All];
					postMeasurementCommand[map,options,otherResults,result];
					result
				],
				{HoldFirst}],
			OptionValue[Attributes]]
	][OptionValue[PreMeasurementCommand],OptionValue[PostMeasurementCommand],
		OptionValue[Resolution]];
Options[AntiCorrelationMeasurementStopTask]=
	Join[{TaskName->"AntiCorrelationMeasurement"},
		Options@AntiCorrelationMeasurementReadTask];
AntiCorrelationMeasurementStopTask[o:OptionsPattern[]]:=
	Function[preMeasurementCommand,
		AntiCorrelationMeasurementReadTask[
			PreMeasurementCommand->Function[{map,options,otherResults},
				preMeasurementCommand[map,options,otherResults];
				TimeHarpStopMeasurement[];
			],TaskName->OptionValue[TaskName],o]
	][OptionValue[PreMeasurementCommand]];
Options[PolarizationMeasurementTask]=Join[{
		TaskName->"PolarizationMeasurement",
		AdditionalDependencies->{},
		PreMeasurementCommand->Function[Null],
		PostMeasurementCommand->Function[Null],
		Attributes->IsMeasurementTask},Options@MeasurePolarization];
PolarizationMeasurementTask[o:OptionsPattern[]]:=
	Function[{preMeasurementCommand,postMeasurementCommand},
		BatchTask[OptionValue[TaskName],
			Flatten@{OptionValue[AdditionalDependencies],OptionsBatchDependencies[o]},
			Function[{map,options,otherResults},
				Module[{result,previousData=PreviousData/.options},
					If[SymbolQ[previousData],
						preMeasurementCommand[map,options,otherResults];
						result=Block[{x,\[Phi]},
								{\[Phi]/.#1[[2]],#1[[1]],#2}&@@
								{Maximize[{#[\[Phi]],0<=\[Phi]<=2*\[Pi]},\[Phi]],
									ExtractRelevantParametersFromFit[#]}&@
								LinearModelFit[Select[#,0<=#[[1]]<=2*\[Pi]&],
									{Cos[x/2],Sin[x/2],Cos[x],Sin[x],Cos[2*x],Sin[2*x]},x]]&@
							MeasurePolarization[
								Sequence@@EvaluateBatchQuantityOptions[
									FilterRules[Join[{o},options],Options@MeasurePolarization],
									otherResults]];
						postMeasurementCommand[map,options,otherResults,result];
						result,previousData]],
				{HoldFirst}],
			OptionValue[Attributes]]
		][OptionValue[PreMeasurementCommand],OptionValue[PostMeasurementCommand]];
Options[PolarizationAngleSettingTask]=Join[{
		TaskName->"PolarizationAngleSettingTask",
		PolarizationMeasurementTaskToUse->"PolarizationMeasurementTask",
		PreMeasurementCommand->Function[Null],
		PostMeasurementCommand->Function[Null],
		AdditionalDependencies->{},Attributes->{AlwaysRestart,IsMeasurementTask}},
	Options@PolarizationRotatorSetAngle];
PolarizationAngleSettingTask[o:OptionsPattern[]]:=
	Function[{preMeasurementCommand,postMeasurementCommand,
			polarizationMeasurementTask},
		BatchTask[OptionValue[TaskName],
			Flatten@{BatchDependencies[polarizationMeasurementTask],
				OptionValue[AdditionalDependencies],OptionsBatchDependencies[o]},
			Function[{map,options,otherResults},
				Module[{pol,rPolarizationMeasurementTask=
							EvaluateBatchQuantity[polarizationMeasurementTask,otherResults]},
					preMeasurementCommand[map,options,otherResults];
					pol=rPolarizationMeasurementTask[[1]];
					PolarizationRotatorSetAngle[pol/2,
						Sequence@@EvaluateBatchQuantityOptions[
								FilterRules[Join[{o},options],
									Options@PolarizationRotatorSetAngle],
								otherResults],
						Asynchronous->False];
					pol;
					postMeasurementCommand[map,options,otherResults,pol];
					pol],
				{HoldFirst}],
			OptionValue[Attributes]]
		][OptionValue[TaskName],OptionValue[PreMeasurementCommand],
			OptionValue[PostMeasurementCommand],
			OptionValue[PolarizationMeasurementTaskToUse]];
Options[TrackerMinCountsFromPolarizatioSettingTask]={
	TaskName->"TrackerMinCountsFromPolarizatioSettingTask",
	PolarizationMeasurementTaskToUse->"PolarizationMeasurementTask",
	AdditionalDependencies->{},Attributes->AlwaysRestart,
	TrackerMinCountsDeterminationFunction->
		Function[{pol,maxCounts,fit},0.8*maxCounts]};
TrackerMinCountsFromPolarizatioSettingTask[o:OptionsPattern[]]:=
	Function[{name,polarizationMeasurementTask,minCountsDeterminationFunction},
		BatchTask[name,Flatten@{polarizationMeasurementTask,
				BatchDependencies[minCountsDeterminationFunction],
				OptionValue[AdditionalDependencies]},
			Function[{map,options,otherResults},
				Module[{rPolarizationMeasurementTask,rMinCountsDeterminationFunction},
					{rPolarizationMeasurementTask,rMinCountsDeterminationFunction}=
						EvaluateBatchQuantity[#,otherResults]&/@
						{polarizationMeasurementTask,minCountsDeterminationFunction};
					{name->minCountsToStop,TrackerMinCountsToStop->minCountsToStop}&[
							rMinCountsDeterminationFunction@@rPolarizationMeasurementTask]],
				{HoldFirst}],
			OptionValue[Attributes]]
		][OptionValue[TaskName],OptionValue[PolarizationMeasurementTaskToUse],
			OptionValue[TrackerMinCountsDeterminationFunction]];
Options[SaturationMeasurementTask]=Join[{
		TaskName->"SaturationMeasurement",
		PreMeasurementCommand->Function[Null],
		PostMeasurementCommand->Function[Null],
		AdditionalDependencies->{},Attributes->IsMeasurementTask,
		BackgroundEstimate->10*^3/250*^-6,
		TerminalCountrateEstimate->250*^3,
		SaturationPowerEstimate->100*^-6},Options@MeasureSaturation];
SaturationMeasurementTask[o:OptionsPattern[]]:=
	Function[{preMeasurementCommand,postMeasurementCommand,
			backGroundEstimate,terminalCountrateEstimate,saturationPowerEstimate},
		BatchTask[OptionValue[TaskName],
			Flatten@{BatchDependencies@{backGroundEstimate,terminalCountrateEstimate,
					saturationPowerEstimate},
				OptionValue[AdditionalDependencies],OptionsBatchDependencies[o]},
			Function[{map,options,otherResults},
				Module[{result,previousData=PreviousData/.options,
						rBackGroundEstimate,rTerminalCountrateEstimate,
						rSaturationPowerEstimate},
					{rBackGroundEstimate,rTerminalCountrateEstimate,
							rSaturationPowerEstimate}=
						EvaluateBatchQuantity[#,otherResults]&/@
						{backGroundEstimate,terminalCountrateEstimate,
							saturationPowerEstimate};
					If[SymbolQ[previousData],
						preMeasurementCommand[map,options,otherResults];
						result=Block[{b,c,x0,x},
								ExtractRelevantParametersFromFit@
								NonlinearModelFit[#,b*x+(c*x)/(x+x0),
									{{b,rBackGroundEstimate},{c,rTerminalCountrateEstimate},
										{x0,rSaturationPowerEstimate}},x]]&@
								MeasureSaturation[
									Sequence@@EvaluateBatchQuantityOptions[
										FilterRules[Join[{o},options],Options@MeasureSaturation],
										otherResults]];
						postMeasurementCommand[map,options,otherResults,result];
						result,
						previousData]],
				{HoldFirst}],
			OptionValue[Attributes]]
		][OptionValue[PreMeasurementCommand],OptionValue[PostMeasurementCommand],
			OptionValue[BackgroundEstimate],OptionValue[TerminalCountrateEstimate],
			OptionValue[SaturationPowerEstimate]];
Options[ODMRcontinuousWaveMeasurementTask]=Join[{
		TaskName->"ODMRcontinuousWaveMeasurement",
		PreMeasurementCommand->Function[Null],
		PostMeasurementCommand->Function[Null],
		AdditionalDependencies->{},
		Attributes->{IsMeasurementTask,TaskCaresAboutMapAdjustment},
		MaxScans->100},
	Options@ODMRcw];
ODMRcontinuousWaveMeasurementTask[
		frequencies:{_?NumericQ..}|_?BatchQuantityQ,
		power:_?NumericQ|_?BatchQuantityQ,o:OptionsPattern[]]:=
	Function[{maxScans,preMeasurementCommand,postMeasurementCommand},
		BatchTask[OptionValue[TaskName],
			Flatten@{BatchDependencies[{maxScans,frequencies,power}],
				OptionValue[AdditionalDependencies],OptionsBatchDependencies[o]},
			Function[{map,options,otherResults},
				Module[{evaluatedOptions=EvaluateBatchQuantityOptions[
							Flatten@Join[{o},options],otherResults],
						rMaxScans,rFrequencies,rPower,result,
						powerTranslationFunction,previousData=PreviousData},
					powerTranslationFunction=MicrowavePowerTranslationFunction
							/.evaluatedOptions
							/.MicrowavePowerTranslationFunction->Function[#1];
					previousData=PreviousData/.evaluatedOptions;
					{rMaxScans,rFrequencies,rPower}=
						If[Head[#]===PlusMinus,#[[1]],#]&@
						EvaluateBatchQuantity[#,otherResults]&/@
						{maxScans,frequencies,power};
					If[SymbolQ[previousData]||previousData[[5]]<rMaxScans,
						preMeasurementCommand[map,options,otherResults];
						result=ODMRcw[map,rFrequencies,
								If[MatchQ[#,{(x_)..}],#[[1]],#]&@
								powerTranslationFunction[rPower,rFrequencies],
								Sequence@@FilterRules[evaluatedOptions,Options@ODMRcw],
								Autorun->True,
								MaxScans->rMaxScans];
						postMeasurementCommand[map,options,otherResults,result];
						result,
						previousData]
					],
				{HoldFirst}],
			OptionValue[Attributes]]
		][OptionValue[MaxScans],OptionValue[PreMeasurementCommand],
			OptionValue[PostMeasurementCommand]];
Options[ODMRpulseSequenceMeasurementTask]=Join[{
		TaskName->"ODMRpulseSequenceMeasurement",
		PreMeasurementCommand->Function[Null],
		PostMeasurementCommand->Function[Null],
		AdditionalDependencies->{},
		Attributes->{IsMeasurementTask,TaskCaresAboutMapAdjustment},
		MaxScans->500},
	Options@ODMRrabi];
ODMRpulseSequenceMeasurementTask[frequency:_?NumericQ|_?BatchQuantityQ,
		power:_?NumericQ|_?BatchQuantityQ,
		pulseSequenceFile:_String|_?BatchQuantityQ,o:OptionsPattern[]]:=
	Function[{maxScans,preMeasurementCommand,postMeasurementCommand},
		BatchTask[OptionValue[TaskName],
			Flatten@{BatchDependencies@{maxScans,frequency,power,
						If[!StringQ[pulseSequenceFile]
								||!StringMatchQ[pulseSequenceFile,"*.seq"|"*.wfm",
									IgnoreCase->True],pulseSequenceFile]},
				OptionValue[AdditionalDependencies],OptionsBatchDependencies[o]},
			Function[{map,options,otherResults},
				Module[{evaluatedOptions=EvaluateBatchQuantityOptions[
							Flatten@Join[{o},options],otherResults],
						rMaxScans,rFrequency,rPower,rPulseSequenceFile,result,
						powerTranslationFunction,previousData},
					powerTranslationFunction=MicrowavePowerTranslationFunction
							/.evaluatedOptions
							/.MicrowavePowerTranslationFunction->Function[#1];
					previousData=PreviousData/.evaluatedOptions;
					{rMaxScans,rFrequency,rPower}=
						If[Head[#]===PlusMinus,#[[1]],#]&@
						EvaluateBatchQuantity[#,otherResults]&/@
						{maxScans,frequency,power};
					rPulseSequenceFile=If[StringQ[pulseSequenceFile]&&
							StringMatchQ[pulseSequenceFile,"*.seq"|"*.wfm",
								IgnoreCase->True],pulseSequenceFile,
						EvaluateBatchQuantity[pulseSequenceFile,otherResults]];
					If[SymbolQ[previousData]||previousData[[7]]<rMaxScans,
						preMeasurementCommand[map,options,otherResults];
						result=ODMRrabi[map,rFrequency,
								powerTranslationFunction[rPower,rFrequency],
								rPulseSequenceFile,
								Sequence@@FilterRules[evaluatedOptions,Options@ODMRrabi],
								NormalizeCounts->True,
								Autorun->True,
								MaxScans->rMaxScans];
						postMeasurementCommand[map,options,otherResults,result];
						result,
						previousData]
					],
				{HoldFirst}],
			OptionValue[Attributes]]
		][OptionValue[MaxScans],OptionValue[PreMeasurementCommand],
			OptionValue[PostMeasurementCommand]];
Options[ODMRpulsedDEERsequenceMeasurementTask]=Join[{
		TaskName->"ODMRpulsedDEERsequenceMeasurementTask",
		SecondaryMicrowavePulseModulationEnabled->True,
		SecondaryMicrowaveIQmodulationEnabled->False},
	Options@ODMRpulseSequenceMeasurementTask];
ODMRpulsedDEERsequenceMeasurementTask[
		frequency1:_?NumericQ|_?BatchQuantityQ,
		power1:_?NumericQ|_?BatchQuantityQ,
		frequency2:_?NumericQ|_?BatchQuantityQ,
		power2:_?NumericQ|_?BatchQuantityQ,
		pulseSequenceFile:_String|_?BatchQuantityQ,
		secondaryMicrowave:_,o:OptionsPattern[]]:=
	Function[{preMeasurementCommand,postMeasurementCommand,
			secondaryMicrowavePulseModulationEnabled,
			secondaryMicrowaveIQModulationEnabled},
		ODMRpulseSequenceMeasurementTask[frequency1,power1,pulseSequenceFile,
			TaskName->OptionValue[TaskName],
			AdditionalDependencies->Join[BatchDependencies[
					{frequency2,power2,secondaryMicrowave,
						secondaryMicrowavePulseModulationEnabled,
						secondaryMicrowaveIQModulationEnabled}],
				OptionValue[AdditionalDependencies]],
			PreMeasurementCommand->Function[{map,options,otherResults},
				preMeasurementCommand[map,options,otherResults];
				Module[{s=Function[ToString[#,CForm]],
						powerTranslationFunction=MicrowavePowerTranslationFunction
							/.EvaluateBatchQuantityOptions[Flatten@Join[{o},options],
								otherResults]
							/.MicrowavePowerTranslationFunction->Function[#1],
						rFrequency2,rPower2,rSecondaryMicrowave,
						rSecondaryMicrowavePulseModulationEnabled,
						rSecondaryMicrowaveIQModulationEnabled},
					{rFrequency2,rPower2,rSecondaryMicrowave,
						rSecondaryMicrowavePulseModulationEnabled,
						rSecondaryMicrowaveIQModulationEnabled}=
							Switch[#,_PlusMinus,#[[1]],_,#]&@
							EvaluateBatchQuantity[#,otherResults]&/@
							{frequency2,power2,secondaryMicrowave,
								secondaryMicrowavePulseModulationEnabled,
								secondaryMicrowaveIQModulationEnabled};
					SCPIcmd[rSecondaryMicrowave,":FREQ:MODE CW"];
					SCPIcmd[rSecondaryMicrowave,":POWER:MODE FIX"];
					SCPIcmd[rSecondaryMicrowave,":OUTP:STATE 0"];
					SCPIcmd[rSecondaryMicrowave,":FREQ "<>s[rFrequency2]];
					SCPIcmd[rSecondaryMicrowave,":POWER "<>
						s[powerTranslationFunction[rPower2,rFrequency2]]];
					SCPIcmd[rSecondaryMicrowave,":PULM:STATE "<>
						If[rSecondaryMicrowavePulseModulationEnabled===True,"ON","OFF"]];
					SCPIcmd[rSecondaryMicrowave,":DM:IQ:STATE "<>
						If[rSecondaryMicrowaveIQModulationEnabled===True,"ON","OFF"]];
					SCPIcmd[rSecondaryMicrowave,":OUTP:STATE 1"]]],
			PostMeasurementCommand->Function[{map,options,otherResults,result},
				SCPIcmd[EvaluateBatchQuantity[secondaryMicrowave,otherResults],
					":OUTP:STATE 0"];
				postMeasurementCommand[map,options,otherResults,result]],
			Sequence@@FilterRules[{o},Options@ODMRpulseSequenceMeasurementTask]]
	][OptionValue[PreMeasurementCommand],OptionValue[PostMeasurementCommand],
		OptionValue[SecondaryMicrowavePulseModulationEnabled],
		OptionValue[SecondaryMicrowaveIQmodulationEnabled]];
Options[ODMRpulsedSpectrumMeasurementTask]=Join[{
		TaskName->"ODMRpulsedSpectrumMeasurement",
		PreMeasurementCommand->Function[Null],
		PostMeasurementCommand->Function[Null],
		AdditionalDependencies->{},
		Attributes->{IsMeasurementTask,TaskCaresAboutMapAdjustment},
		MaxScans->1000},
	Options@ODMRpulsed];
ODMRpulsedSpectrumMeasurementTask[
		frequencies:{_?NumericQ..}|_?BatchQuantityQ,
		power:_?NumericQ|_?BatchQuantityQ,
		targetRabiFrequency:_?NumericQ|_String|_?BatchQuantityQ,
		o:OptionsPattern[]]:=
	Function[{maxScans,preMeasurementCommand,postMeasurementCommand},
		BatchTask[OptionValue[TaskName],
			Flatten@{BatchDependencies@{maxScans,frequencies,power,
					If[!NumericQ[targetRabiFrequency]||!StringQ[targetRabiFrequency]||
							!StringMatchQ[targetRabiFrequency,"*.seq"|"*.wfm",
								IgnoreCase->True],targetRabiFrequency]},
				OptionValue[AdditionalDependencies],OptionsBatchDependencies[o]},
			Function[{map,options,otherResults},
				Module[{evaluatedOptions=EvaluateBatchQuantityOptions[
							Flatten@Join[{o},options],otherResults],
						rMaxScans,rFrequencies,rPower,rTargetRabiFrequency,result,
						powerTranslationFunction,previousData},
					powerTranslationFunction=MicrowavePowerTranslationFunction
							/.evaluatedOptions
							/.MicrowavePowerTranslationFunction->Function[#1];
					previousData=PreviousData/.evaluatedOptions;
					{rMaxScans,rFrequencies,rPower}=
						Switch[Head[#],_List,#0/@#,PlusMinus,#[[1]],_,#]&@
						EvaluateBatchQuantity[#,otherResults]&/@
						{maxScans,frequencies,power};
					rTargetRabiFrequency=If[StringQ[targetRabiFrequency]
								&&StringMatchQ[targetRabiFrequency,"*.seq"|"*.wfm",
									IgnoreCase->True],targetRabiFrequency,
						EvaluateBatchQuantity[targetRabiFrequency,otherResults]];
					If[SymbolQ[previousData]||previousData[[6]]<maxScans,
						preMeasurementCommand[map,options,otherResults];
						result=ODMRpulsed[map,rFrequencies,
								If[MatchQ[#,{(x_)..}],#[[1]],#]&@
								powerTranslationFunction[rPower,rFrequencies],
								If[NumericQ[rTargetRabiFrequency],rTargetRabiFrequency,0],
								Sequence@@FilterRules[evaluatedOptions,Options@ODMRpulsed],
								MicrowaveSequenceForPulsing->If[StringQ[rTargetRabiFrequency],
									rTargetRabiFrequency,Automatic],
								NormalizeCounts->True,
								Autorun->True,
								MaxScans->rMaxScans];
						postMeasurementCommand[map,options,otherResults,result];
						result,
						previousData]
					],
				{HoldFirst}],
			OptionValue[Attributes]]
		][OptionValue[MaxScans],OptionValue[PreMeasurementCommand],
			OptionValue[PostMeasurementCommand]];
Options[ODMRpulsedDEERspectrumMeasurementTask]=Join[{
		TaskName->"ODMRpulsedDEERspectrumMeasurement",
		SecondaryMicrowavePulseModulationEnabled->True,
		SecondaryMicrowaveIQmodulationEnabled->False},
	Options@ODMRpulsedSpectrumMeasurementTask];			
ODMRpulsedDEERspectrumMeasurementTask[
		frequencies:{_?NumericQ..}|_?BatchQuantityQ,
		power:_?NumericQ|_?BatchQuantityQ,
		pulseFrequency:_?NumericQ|_?BatchQuantityQ,
		pulsePower:_?NumericQ|_?BatchQuantityQ,
		pulseSequenceFile:_String|_?BatchQuantityQ,
		countRepetitions:_?NumericQ|_?BatchQuantityQ,
		secondaryMicrowave:_,o:OptionsPattern[]]:=
	Function[{preMeasurementCommand,postMeasurementCommand,
			secondaryMicrowavePulseModulationEnabled,
			secondaryMicrowaveIQModulationEnabled},
		ODMRpulsedSpectrumMeasurementTask[frequencies,power,pulseSequenceFile,
			TaskName->OptionValue[TaskName],
			AdditionalDependencies->Join[BatchDependencies[
					{pulseFrequency,pulsePower,secondaryMicrowave,
						secondaryMicrowavePulseModulationEnabled,
						secondaryMicrowaveIQModulationEnabled}],
				OptionValue[AdditionalDependencies]],
			PreMeasurementCommand->Function[{map,options,otherResults},
				preMeasurementCommand[map,options,otherResults];
				Module[{s=Function[ToString[#,CForm]],
						powerTranslationFunction=MicrowavePowerTranslationFunction
							/.EvaluateBatchQuantityOptions[Flatten@Join[{o},options],
								otherResults]
							/.MicrowavePowerTranslationFunction->Function[#1],
						rPulseFrequency,rPulsePower,rSecondaryMicrowave,
						rSecondaryMicrowavePulseModulationEnabled,
						rSecondaryMicrowaveIQModulationEnabled},
					{rPulseFrequency,rPulsePower,rSecondaryMicrowave,
						rSecondaryMicrowavePulseModulationEnabled,
						rSecondaryMicrowaveIQModulationEnabled}=
							Switch[#,_PlusMinus,#[[1]],_,#]&@
							EvaluateBatchQuantity[#,otherResults]&/@
							{frequency2,power2,secondaryMicrowave,
								secondaryMicrowavePulseModulationEnabled,
								secondaryMicrowaveIQModulationEnabled};
					SCPIcmd[rSecondaryMicrowave,":FREQ:MODE CW"];
					SCPIcmd[rSecondaryMicrowave,":POWER:MODE FIX"];
					SCPIcmd[rSecondaryMicrowave,":OUTP:STATE 0"];
					SCPIcmd[rSecondaryMicrowave,":FREQ "<>s[rPulseFrequency]];
					SCPIcmd[rSecondaryMicrowave,":POWER "<>
						s[powerTranslationFunction[rPulsePower,rPulseFrequency]]];
					SCPIcmd[rSecondaryMicrowave,":PULM:STATE "<>
						If[rSecondaryMicrowavePulseModulationEnabled===True,"ON","OFF"]];
					SCPIcmd[rSecondaryMicrowave,":DM:IQ:STATE "<>
						If[rSecondaryMicrowaveIQModulationEnabled===True,"ON","OFF"]];
					SCPIcmd[rSecondaryMicrowave,":OUTP:STATE 1"]]],
			PostMeasurementCommand->Function[{map,options,otherResults,result},
				SCPIcmd[EvaluateBatchQuantity[secondaryMicrowave,otherResults],
					":OUTP:STATE 0"];
				postMeasurementCommand[map,options,otherResults,result]],
			CountRepetitions->countRepetitions,
			Sequence@@FilterRules[{o},Options@ODMRpulsedSpectrumMeasurementTask]]
	][OptionValue[PreMeasurementCommand],OptionValue[PostMeasurementCommand],
		OptionValue[SecondaryMicrowavePulseModulationEnabled],
		OptionValue[SecondaryMicrowaveIQmodulationEnabled]];
Options[ExtractDataFromMeasurementResult]={
	ChannelToExtract->0,DataTypeToExtract->"rawData",WrapInPlot->False,
		PlotOptions->{Joined->True,PlotRange->All}};
ExtractDataFromMeasurementResult::illegalChannel=
	"illegal channel `1` requested, data only has `2` channel(s).";
ExtractDataFromMeasurementResult::unsupportedDataType=
	"data type \"`1`\" is not supported.";
ExtractDataFromMeasurementResult::notPulsedMeasurement=
	"non-pulsed measurement has no normalized data.";
ExtractDataFromMeasurementResult[m_,o:OptionsPattern[]]:=
	With[{convertGraphicsToData=Function[gData,
			gData/.x_Graphics:>Cases[x,(Point|Line)[l_List]:>l,\[Infinity]][[1]]]},
		With[{aggregatorFunction=Function[{gData,aggregator},
						Function[data,Switch[#,0,
								Transpose[Function[{x,y},{Mean[x],aggregator[y]}]@@
									Transpose[data,{2,3,1}]],
								_Integer?(1<=#<=Length[data]&),data[[#]],
								_,Message[ExtractDataFromMeasurementResult::illegalChannel,
									#,Length[data]];{}]&@OptionValue[ChannelToExtract]
						]@convertGraphicsToData[gData]],
				isPulsedMeasurement=MatchQ[m,{{__Graphics},{{__Graphics}...},
						{{{_Graphics,_Graphics}...},
							{{{{_Graphics,_Graphics},{_Graphics,_Graphics}}...}...}},___}?
							(Length[#2]==3&&#2[[3]]==2&&
									With[{nc=#2[[1]],nx=#2[[2]]},
										Dimensions[#1[[3,1]]]=={nc,2,nx,2}&&
										Dimensions[#1[[3,2]]]=={nc,nc,2,2,nx,2}
									]&[#,Dimensions[#[[1]]]]&@
								convertGraphicsToData[#[[1;;3]]]&)]},
			If[OptionValue[WrapInPlot]===True,
				ListPlot[#,Sequence@@OptionValue[PlotOptions]],#]&@
			StringSwitch[OptionValue[DataTypeToExtract],
				"raw"~~(""|"Data"),aggregatorFunction[
					If[isPulsedMeasurement,m[[3,1,All,1]],m[[1]]],Total],
				"normalized"~~(""|"Data"),If[isPulsedMeasurement,
					aggregatorFunction[m[[1]],Mean],
					Message[ExtractDataFromMeasurementResult::notPulsedMeasurement];{}],
				____,Message[ExtractDataFromMeasurementResult::unsupportedDataType];{},
				IgnoreCase->True]
		]
	]/;MatchQ[m,{{__Graphics},{{__Graphics}...},___}]&&
		(Dimensions[m[[2]]]=={#,#}&@Length[m[[1]]]);
Options[ODMRspectrumFitTask]=Join[{
		TaskName->"ODMRspectrumFitTask",
		Attributes->AlwaysRestart,
		MeasurementToFit->"ODMRcontinuousWaveMeasurement"~~___,
		FitTag->Function[taskName,taskName<>"Fit"],
		FitRawData->True,AdditionalDependencies->{}},
	Options@ODMRautoLineFit];
ODMRspectrumFitTask[o:OptionsPattern[]]:=
	Function[{stringPattern,tag,fitRawData},
		BatchTask[OptionValue[TaskName],
			Flatten@{OptionValue[MeasurementToFit],
				OptionValue[AdditionalDependencies],OptionsBatchDependencies[o]},
			Function[{map,options,otherResults},
				Function[{name,measurement},
					With[{isPulsedSpectrum=Length[measurement]>5,
							fitName=Switch[Head[tag],Function,tag[name],String,name<>tag,
								_,name<>"Fit"]},
						Module[{data=ExtractDataFromMeasurementResult[measurement,
								DataTypeToExtract->If[fitRawData||!isPulsedSpectrum,"raw",
									"normalized"]]},
							If[Length[#]==0||data=!=
									Cases[Last[#],(Line|Point)[l_List]:>l,\[Infinity]][[1]],
								fitName->ODMRautoLineFit[ListLinePlot[data,PlotRange->All],
									Sequence@@EvaluateBatchQuantityOptions[
											FilterRules[Join[{o},options],Options@ODMRautoLineFit],
										otherResults]][[1]],
								Last[#]]&@
							If[ListQ[#],Cases[#,HoldPattern[#->_]&@fitName],{}]&[
								PreviousResults/.options]]]
				]@@#&/@Cases[otherResults,_Rule?(StringMatchQ[#[[1]],stringPattern]&)],
				{HoldFirst}],
			OptionValue[Attributes]]
	][OptionValue[MeasurementToFit],OptionValue[FitTag],
		OptionValue[FitRawData]===True];
Options[ODMRspectrumFitPeakExtractorTask]={
	TaskName->"ODMRspectrumFitPeakExtractorTask",
	Attributes->AlwaysRestart,
	FitToExtractFrom->"ODMRcontinuousWaveMeasurement"~~___~~"Fit",
	PeakSuffix->"Peak",BackgroundSuffix->"Background"};
ODMRspectrumFitPeakExtractorTask[o:OptionsPattern[]]:=
	Function[{stringPattern,bgParameterName,peakParameterNames},
		BatchTask[OptionValue[TaskName],
			{ConditionalBatchQuantity[OptionValue[FitToExtractFrom],
					Function[fit,MatchQ[fit,{_,Style[Grid[_?MatrixQ,___],___],___}]]]},
			Function[{map,options,otherResults},
				Flatten[Function[{name,data},{
						bgParameterName[name]->PlusMinus@@data[[2,1,1,2,2;;3]],
						MapIndexed[
							Rule@@#&/@Transpose[{peakParameterNames[name,#2[[1]]],#1}]&,
							Partition[PlusMinus@@#&/@data[[2,1,1,3;;,2;;3]],3]]}
					]@@#&/@Cases[otherResults,
						HoldPattern[_?(StringMatchQ[#,stringPattern]&)->
							{_,Style[Grid[_?MatrixQ,___],___],___}]]],
				{HoldFirst}],
			OptionValue[Attributes]]
	][OptionValue[FitToExtractFrom],
		If[Head[#]===Function,#,
			Function[name,name<>#]&@If[StringQ[#],#,"Background"]
		]&@OptionValue[BackgroundSuffix],
		If[Head[#]===Function,#,Function[{name,i},
				Function[s,name<>#<>ToString[i]<>s]/@
					{"Frequency","FWHM","Contrast"}]&@If[StringQ[#],#,"Peak"]
		]&@OptionValue[PeakSuffix]];
Options[ODMRpulseSequenceOscillationFitTask]=Join[{
		TaskName->"ODMRpulseSequenceOscillationFitTask",
		Attributes->{},
		MeasurementToFit->"ODMRpulseSequenceMeasurementTask"~~___,
		FitTag->Function[taskName,taskName<>"Fit"],
		FitRawData->True,AdditionalDependencies->{}},
	Options@ODMRdampedOscillationFit];
ODMRpulseSequenceOscillationFitTask[o:OptionsPattern[]]:=
	Function[{stringPattern,tag,fitRawData},
		BatchTask[OptionValue[TaskName],
			Flatten@{OptionValue[MeasurementToFit],
				OptionValue[AdditionalDependencies],OptionsBatchDependencies[o]},
			Function[{map,options,otherResults},
				Function[{name,measurement},
						Module[{fitName=Switch[Head[tag],Function,tag[name],
									String,name<>tag,_,name<>"Fit"],
								data=ExtractDataFromMeasurementResult[measurement,
										DataTypeToExtract->If[fitRawData,"raw","normalized"]]},
							If[Length[#]==0||data=!=
									Cases[Last[#],(Line|Point)[l_List]:>l,\[Infinity]][[1]],
								fitName->ODMRdampedOscillationFit[data,
										Sequence@@EvaluateBatchQuantityOptions[
											FilterRules[Join[{o},options],
												Options@ODMRdampedOscillationFit],
											otherResults]],
								Last[#]]&@
							If[ListQ[#],Cases[#,HoldPattern[#->_]&@fitName],{}]&[
								PreviousResults/.options]]
				]@@#&/@Cases[otherResults,_Rule?(StringMatchQ[#[[1]],stringPattern]&)],
				{HoldFirst}],
			OptionValue[Attributes]]
	][OptionValue[MeasurementToFit],OptionValue[FitTag],
		OptionValue[FitRawData]===True];
Options[ODMRpulseSequenceOscillationFitParameterExtractorTask]={
	TaskName->"ODMRpulseSequenceOscillationFitParameterExtractorTask",
	Attributes->AlwaysRestart,
	FitToExtractFrom->"ODMRpulseSequenceMeasurementTask"~~___~~"Fit",
	Suffix->""};
ODMRpulseSequenceOscillationFitParameterExtractorTask[o:OptionsPattern[]]:=
	Function[{stringPattern,suffices},
		BatchTask[OptionValue[TaskName],
			{ConditionalBatchQuantity[OptionValue[FitToExtractFrom],
					Function[fit,MatchQ[fit,{_,Style[Grid[_?MatrixQ,___],___],___}]]]},
			Function[{map,options,otherResults},
				Flatten[Function[{name,data},
							Rule@@#&/@Transpose[{suffices[name],
									PlusMinus@@#&/@data[[2,1,1,2;;,2;;3]]}]
					]@@#&/@Cases[otherResults,
						HoldPattern[_?(StringMatchQ[#,stringPattern]&)->
							{_,Style[Grid[_?MatrixQ,___],___],___}]]],
				{HoldFirst}],
			OptionValue[Attributes]]
	][OptionValue[FitToExtractFrom],If[Head[#]===Function,#,
			Function[name,Function[s,name<>#<>s]/@
					{"Amplitude","Background","BackgroundAmplitude","Frequency",
						"AmplitudeTimeConstant","BackgroundTimeConstant","Phase"}
			]&@If[StringQ[#],#,""]
		]&@OptionValue[Suffix]];
Options[ODMRdampedOscillationFit]=Join[{
		BackgroundEstimate->Function[Mean[#[[2]]&/@#]],
		BackgroundAmplitudeEstimate->Function[(Max[#]-Min[#])/2&[#[[2]]&/@#]],
		BackgroundTimeConstantEstimate->Function[(Max[#]-Min[#])/2&[#[[1]]&/@#]],
		AmplitudeEstimate->Function[(Max[#]-Min[#])/2&[#[[2]]&/@#]],
		AmplitudeTimeConstantEstimate->Function[(Max[#]-Min[#])/2&[#[[1]]&/@#]],
		PhaseEstimate->0,FrequencyEstimate->"FFT"},Options@NonlinearModelFit];
ODMRdampedOscillationFit[data:{{_?NumericQ,_?NumericQ}..},o:OptionsPattern[]]:=
	With[{iStringMatcher=Function[str,_?(StringMatchQ[#,str,IgnoreCase->True]&)]},
		Block[{A,B,C,fr,t,T0,T,\[Phi],
				exEs=Function[optionName,
					Switch[#,_Function|_Symbol,#[data],
					_,#]&@OptionValue[optionName]]},
			ExtractRelevantParametersFromFit@
			NonlinearModelFit[data,
				B*(1-C*E^(-t/T0)
					-A/2*Cos[2*\[Pi]*fr*t+\[Phi]]* E^(-t/T)),
				{{A,exEs[AmplitudeEstimate]},
				{B,exEs[BackgroundEstimate]},
				{C,exEs[BackgroundAmplitudeEstimate]},
				{fr,Switch[#,
						iStringMatcher["FFT"],ListMax[
								Select[TaggedFourier[data],1*^6<=#[[1]]<=40*^6&],
								Abs[#[[2]]]&][[2,1]],
						iStringMatcher["FirstMinimum"],
							1/2/Subtract@@(data[[#,1]]&/@{ListMax[data,-#[[2]]&][[1]],1}),
						_Function|_Symbol,#[data],
						_,#]&@
					OptionValue[FrequencyEstimate]},
				{T,exEs[AmplitudeTimeConstantEstimate]},
				{T0,exEs[BackgroundTimeConstantEstimate]},
				{\[Phi],exEs[PhaseEstimate]}},t]]];
ODMRdampedOscillationFit[data:{{{_?NumericQ,_?NumericQ}..}..},
		o:OptionsPattern[]]:=
	ODMRdampedOscillationFit[
		Function[{x,y},Transpose[{x[[1]],Mean[y]}]]@@Transpose[#,{2,3,1}],o];
ODMRdampedOscillationFit[data:_Graphics|{__Graphics},o:OptionsPattern[]]:=
	ODMRdampedOscillationFit[
		Function[{x,y},Transpose[{x[[1]],Mean[y]}]]@@
		Transpose[Cases[data,(Line|Point)[l_List]:>l,\[Infinity]],{2,3,1}],o];			
ODMRdampedOscillationFit[data:{{__Graphics},___},o:OptionsPattern[]]:=
	ODMRdampedOscillationFit[data[[1]],o];
ImportBatchResults[file_String]:=
	If[FileExistsQ[file],
		Switch[#,{_,_,_?NVmapQ,_?ConfocalImageQ,{___Rule}},
			Join[{"ID"->#[[1]],"Time"->#[[2]],"Map"->#[[3]],
					"ImageAfterSelection"->#[[4]]},
				Join@@Module[{transformOscillationFitPhase=
						Function[MapAt[#*Pi/180&,#,{2,1,1,8,2;;3}]]},
					Switch[#1,
						"g2",{"AntiCorrelationMeasurement"->#2},
						"polarization",If[MatchQ[#2,{_,_,_}],
							Module[{fit=#2[[1]],\[Phi]max=\[Pi]/180*#2[[2]],image=#2[[3]]},
								{"PolarizationMeasurement"->{\[Phi]max,
										SortBy[#,Abs[#[[1]]-\[Phi]max]&][[1,2]]&@
										Cases[fit,Line[l_List]:>l,\[Infinity]][[1]],fit},
									"ImageAfterPolarizationMeasurementTask"->image}],{}],
						"saturation",If[MatchQ[#2,{_,_}],{"SaturationMeasurement"->#2[[1]],
								"ImageAfterSaturationMeasurement"->#2[[2]]},{}],
						"ODMR_cw",If[MatchQ[#2,{_List,{__List},_}],
							{"ODMR_cw"->#2[[1]],"ODMR_cwFit"->#2[[2,1]],
								"ImageAfterODMR_cw"->#2[[3]]},{}],
						"ODMR_Rabi",If[MatchQ[#2,{_List,_List,_}],
							{"ODMR_Rabi"->#2[[1]],
								"ODMR_RabiFit"->transformOscillationFitPhase[#2[[2]]],
								"ImageAfterODMR_Rabi"->#2[[3]]},{}],
						"ODMR_Ramsey",If[MatchQ[#2,{_List,_List,_}],
							{"ODMR_Ramsey"->#2[[1]],
								"ODMR_RamseyFit"->transformOscillationFitPhase[#2[[2]]],
								"ImageAfterODMR_Ramsey"->#2[[3]]},{}],
						"ODMR_Hahn",If[MatchQ[#2,{_List,_List,_}],
							{"ODMR_Hahn"->#2[[1]],
								"ODMR_HahnFit"->transformOscillationFitPhase[#2[[2]]],
								"ImageAfterODMR_Hahn"->#2[[3]]},{}],
						"ODMR_pulsed",If[MatchQ[#2,{_List,_}],
							{"ODMR_pulsed"->#2[[1]],"ImageAfterODMR_pulsed"->#2[[2]]},{}],
						"ODMR_DEER",If[MatchQ[#2,{_List,_}],
							{"ODMR_DEER"->#2[[1]],"ImageAfterODMR_DEER"->#2[[2]]},{}],
						_,{}]&@@#&/@#[[5]]]//DeleteCases[#,_String->_Symbol]&],
			{__Rule},#,_,$Failed["unknown result format for file "<>file]
		]&@Quiet@Get[file],{}];
Options[ODMRpulsePowerCalculatorTask]={
	TaskName->"TargetPulsePowerCalculator",Attributes->AlwaysRestart,
	AdditionalDependencies->{}};
ODMRpulsePowerCalculatorTask[
		rabiFrequency:_?NumericQ|PlusMinus[_?NumericQ,_?NumericQ]|_?BatchQuantityQ,
		rabiPower:_?NumericQ|PlusMinus[_?NumericQ,_?NumericQ]|_?BatchQuantityQ,
		targetRabiFrequency:_?NumericQ|PlusMinus[_?NumericQ,_?NumericQ]
			|_?BatchQuantityQ,
		resultName:_String|_?BatchQuantityQ,
		o:OptionsPattern[]]:=
	BatchTask[OptionValue[TaskName],
		Join[BatchDependencies@{If[!StringQ[#],#]&@resultName,rabiFrequency,
				rabiPower,targetRabiFrequency},OptionValue[AdditionalDependencies]],
		Function[{map,options,otherResults},
			Module[{rResultName,rRabiFrequency,rRabiPower,rTargetRabiFrequency},
				{rRabiFrequency,rRabiPower,rTargetRabiFrequency}=
						If[Head[#]===PlusMinus,#[[1]],#]&@
						EvaluateBatchQuantity[#,otherResults]&/@
						{rabiFrequency,rabiPower,targetRabiFrequency};
				rResultName=If[StringQ[#],#,
					EvaluateBatchQuantity[#,otherResults]]&@resultName;
				rResultName->rRabiPower
					+20*Log[10,rTargetRabiFrequency/rRabiFrequency]],
			{HoldFirst}],
	  OptionValue[Attributes]];
